{$I-,R-,F+,O+}
Unit RV;
Interface

uses dos, crt, strings, mouse;

{===== CRT SECTION =====}
Const
     On=1;    Off=0;
     Rus=1;   Eng=2;
     Left=1;  Right=2;
     DaysRus   :array [0..6] of String[11] =
('ᥭ','쭨','୨','।','⢥','⭨','㡡');
     DaysEng   :array [0..6] of String[11] =
('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
Var

   GmaxX,GmaxY          :byte;
   HalfMaxX,HalfMaxY    :byte;
   OldMaxX,OldMaxY      :byte;
   SavedCurX,SavedCurY  :byte;

  Regs          : registers;
  TotalRAM,
  AvailRAM,
  TotalXMS,
  PagesInst,
  PagesAvail,
  TotalEXP,
  AvailEXP,
  SystemEXP,
  OtherEXP,
  i,NumHandles  : word;
  EXTInfo,
  EXPInstalled  : boolean;
  EXPVersion    : string;
  PList         : array[1..512] of record
                                     Handle,Pages: word;
                                   end;



procedure Cls;
procedure ClrBox        (x1,y1,x2,y2:byte);
procedure Colour        (paper,ink : byte);

procedure Print         (x,y:byte; s:string);
procedure MPrint        (x,y:byte; s:string);
procedure CMPrint       (paper,ink,x,y:word; s:string);
procedure PrintSelf     (paper,ink,x,y,len:byte);
procedure MWrite        (s:string);
procedure CMWrite       (paper,ink:byte; s:string);
procedure Centre        (y:byte; s:string);
procedure MCentre       (y:byte; s:string);
procedure CMCentre      (paper,ink,y:byte; s:string);

procedure GotoXY        (x,y:Byte);
function  MaxX          :Byte;
function  MaxY          :Byte;
function  WhereX        :Byte;
function  WhereY        :Byte;
function  GetXY         (x,y:Byte):Char;

procedure Set80x25;
procedure Set80x28;
procedure Set80x30;
procedure Set80x43;
procedure Set80x50;
procedure Set132x25;
procedure Set132x28;
procedure Set132x50;
procedure SetTextMode   (mx,my:byte);
procedure SaveTextMode;
procedure RestTextMode;
procedure GetCurTextMode;

procedure CurOn;
procedure CurOff;
procedure SaveCur;
procedure RestCur;
procedure WaitKey;

function  CurDateTime(lan:byte)   :string;
function  CurDate       :string;
function  CurDay(lan:byte)        :string;
function  CurTime       :string;

procedure Flash         (OffOn:byte);
procedure Border        (colour:Byte);
procedure Ring;
procedure Beep          (ton,len:integer);
procedure Wait          (Seconds:Word);
procedure rPause;
function  Bit           (n,b:byte):boolean;

function  GetCursor     :word;
procedure SetCursor     (curs:word);

function  longHi        (num:longint):word;
function  longLo        (num:longint):word;


{===== DOS SECTION =====}

Const
    _dir=1; _name=2; _ext=3;
Type
    CpuType=(c8088,c8086,c80286,c80386,c80486,Pentium,PentiumPRO);
function LZ(w:Word):String;
function LZZ(w:Word):String;
function GetOf(fullpath:string; what:byte):string;

function RunBy:string;

function IsDriveValid(cDrive: Char; Var bLocal, bSUBST: Boolean): Boolean;
function GetAllDrivers:string;
function CheckDrv(drv:char):byte;
function CheckDir(direct:string):byte;
function CheckFile(myfile:string):byte;
function CheckDirFile(fullname:string):byte;
function CheckWrite(drv:char):boolean;

function FileTime(FileName: string): string;
function FileDate(FileName: string): string;
function FileLen(FileName: string): longint;

function GetVolSerialNo(DriveNo:Byte): string;
function GetVolName(DriveNo:Byte): string;
Function CreateDir(full:string):byte;
function CurentDir:string;

function GetProfile(filename,group,key:string; var str:string):byte;
function WriteProfile(filename,group,key,str:string):byte;

function CpuID(var cpun:integer) : string;
function CpuCLK:string;
Function EMM_Installed: Boolean;
Function XMS_Installed: Boolean;
procedure GetTotalMemoryInfo;

function FindFile(findfilename:string):string;

procedure FileCreate(f:string);
procedure FileDelete(fn:string);
procedure MakeFile(name:string; bytes:longint; code:byte);

procedure Str2FileOfChr(fl:string; num:longint; s:string);
procedure Str2FileOfStr(name, str:string);

procedure FileCopy(source,dest:string; add:boolean);
procedure CopyData(source,dest:string; from,bytes:longint);

procedure Ecran(s:pointer);

function eFiles(n:longint; lang:byte):string;
function ewFiles(n:longint; lang:byte):string;
procedure WhatFlopp(var DiskA, DiskB:byte);{}


Function GetFileAttr(FileName:PChar):integer;
Procedure SetFileAttr(FileName:PChar; Attr:word);
Function IsNotDriveReady (DriveSpec : Char) : Boolean; {A,B,etc}



{----- CD-ROM SUBSECTION -----}
Var
   DrvName   :CHAR;
   DrvCount  :WORD;
   IsMSCDEX,
   IsCDROM   :BOOLEAN;

procedure CD_ROMdat(VAR DrvCount:WORD;
                    VAR FirstDrv:CHAR;
                    VAR IsMSCDEX:BOOLEAN;
                    VAR IsCDROM:BOOLEAN);
function  ItCDRom  (drv:char):boolean;






{===== DOS95 LONG NAMES SECTION =====}

type
 TLSearchRec=record
  Attr:longint;
  CreationTime,LastAccessTime,LastModTime:comp; { See below for conversion }
  HiSize,LoSize:longint;
  Reserved:comp;
  Name:array[0..259] of char;
  ShortName:array[0..13] of char; { Only if longname exists }
  Handle:word;
 end;

function LFindFirst(FileSpec:pchar; Attr:word; var SRec:TLSearchRec):word;
{ Search for files }

function LFindNext(var SRec:TLSearchRec):word;
{ Find next file }

function LFindClose(var SRec:TLSearchRec):word;
{ Free search handle }

function LTruename(FileName:pchar; Result:pchar):word;
{ Return complete path, if relative uppercased longnames added, }
{ in buffer Result (261 bytes) }

function LGetShortName(FileName:pchar; Result:pchar):word;
{ Return complete short name/path for input file/path in buffer }
{ Result (79 bytes) }

function LGetLongName(FileName:pchar; Result:pchar):word;
{ Return complete long name/path for input file/path in buffer }
{ Result (261 bytes) }

function LFileSystemInfo(RootName:pchar; FSName:pchar; FSNameBufSize:word;
 var Flags,MaxFileNameLen,MaxPathLen:word):word;
{ Return File System Information, for FSName 32 bytes should be sufficient }
{ Rootname is for example 'C:\' }
{ Flags: }
{ bit
{  0   searches are case sensitive }
{  1   preserves case in directory entries }
{  2   uses Unicode characters in file and directory names }
{ 3-13 reserved (0) }
{ 14   supports DOS long filename functions }
{ 15   volume is compressed }


function LErase(Filename:pchar):word;
{ Erase file }

function LMkDir(Directory:pchar):word;
{ Make directory }

function LRmDir(Directory:pchar):word;
{ Remove directory }

function LChDir(Directory:pchar):word;
{ Change current directory }

function LGetDir(Drive:byte; Result:pchar):word;
{ Get current drive and directory. Drive: 0=current, 1=A: etc. }

function LGetAttr(Filename:pchar; var Attr:word):word;
{ Get file attributes}

function LSetAttr(Filename:pchar; Attr:word):word;
{ Set file attributes }

function LRename(OldFilename,NewFilename:pchar):word;
{ Rename file }

function LTimeToDos(var LTime:comp):longint;
{ Convert 64-bit number of 100ns since 01-01-1601 UTC to local DOS format time
}{ (LTime is var to avoid putting it on the stack) }

procedure UnpackLTime(var LTime:comp; var DT:DateTime);
{ Convert 64-bit time to date/time record }






{===== STRING SECTION =====}

function Space      (len:integer)                   :string;
function NoSpace    (s:string)                      :string;
function NoSpaceLR  (s:string)                      :string;
function NoSpaceR   (s:string)                      :string;
function NoSpaceL   (s:string)                      :string;
function Mid        (str:string; ind1,ind2:integer) :string;
function MidCh      (str:string; index:integer)     :char;
function Strr       (tempein:longint)               :string;
function Vall       (tempein:string)                :longint;
function Fill       (len:byte; symb:char)           :string;
function StrLo      (s:string)                      :string;
function StrHi      (s:string)                      :string;
function CodeStr    (ent:string; code:byte)         :string;
function DeCodeStr  (ent:string; code:byte)         :string;
function ReverseStr (s:string)                      :string;
function no1013     (st:string)                     :string;
function AsciiOnly  (st:string)                     :string;
function NumOnly    (st:string)                     :string;
function ExtNum     (n:string)                      :string;
function ASCIZ2Str  (ASCIZ: array of Char)          :string;
function WithOut    (s,chars:string)                :string;
function ChangeChar (s:string; char1,char2:char)    :string;
function CLen       (s:string)                      :integer;
function CCLen      (s:string)                      :integer;
function sLexpand   (s:string; tob:byte)            :string;
function sRexpand   (s:string; tob:byte)            :string;
Function Wild       (input_word,wilds:String;upcase_wish:boolean):Boolean;
function DnCase     (c:char)                        :char;


{===== PUTS SECTION =====}

Type
{  ScreenImage = Array [0..2499] of Word;{}
  ScreenImage = Pointer;{}
  FrameRec=Record
            x1    : byte;
            y1    : byte;
            x2    : byte;
            y2    : byte;
            area  : ScreenImage;
           End;
  SavedWin       = FrameRec;

Const
  MenuMax=50;

var
  SavedWins      :array[1..10] of SavedWin;
  WinNum         :Byte;

  menu_kod       :char;
  menu_f         :integer;
  menu_posx,
  menu_posy      :integer;
  menu_total     :integer;
  menu_name      :array[1..MenuMax] of string;
  menu_ins       :array[1..MenuMax] of boolean;
  menu_mayins    :boolean;
  menu_title     :string;
  menu_visible   :integer;

  menu_bkNT,menu_txtNT,
  menu_bkST,menu_txtST,
  menu_bkMarkNT,menu_txtMarkNT,
  menu_bkMarkST,menu_txtMarkST:  integer;

  scanf_esc      :boolean;

  w_animation:boolean;
  w_twosided:boolean;
  w_rama:boolean;
  w_shadow:boolean;


Type
  string160=string[160];
Const
  run=1; pro=0;

procedure ScrIni;

procedure SaveScr           (x1,y1,x2,y2:byte);
procedure RestScr;

procedure BasePutWin        (paper,ink,xx1,yy1,xx2,yy2:integer);
procedure PutWin            (x1,y1,x2,y2:integer);
procedure SPutWin           (x1,y1,x2,y2:integer);
procedure SCPutWin          (p,i,x1,y1,x2,y2:integer);
procedure PutTitleWin       (title:string; x1,y1,x2,y2:integer);
procedure SPutTitleWin      (title:string; x1,y1,x2,y2:integer);

procedure Message           (tekst:string);
function  WaitMessage       (tekst:string):byte;
procedure NotWaitMessage    (paper,ink:byte; tekst:string);
procedure ErrorMessage      (tekst:string);
function  ErrorWaitMessage  (tekst:string):byte;

procedure StatusBar         (s:string160);
procedure CStatusBar        (paper,ink,papermark,inkmark,putfrom:byte; s:string160);
procedure StatusLine        (paper,x,y:integer; s:string);
procedure StatusLineColor   (paper,ink,papermark,inkmark,x,y:integer; s:string);
procedure CStatusLineColor  (paper,ink,inkmark,y:integer; s:string);
procedure ProcessBar        (act,per,total:byte; title:string);

function  Question          (quest:string; lan:byte):boolean;
function  Sure              (lan:byte):boolean;
function  Stop              (lan:byte):boolean;

function  Scanf             (scanf_posx, scanf_posy:byte;
                             scanf_str:string;
                             scanf_total, scanf_visible,
                             scanf_cur:byte):string;
function  ChooseItem:byte;
function  GetScrStr         (x,y,len:integer):string;
function  ChooseDrive       (w,typ,lang:byte; cd:string):char;

procedure CButton           (paper,ink,spaper,sink,x,y:byte; s:string; active:boolean);
procedure rvPutsInit;


{===== KEYBOARD SECTION =====}
const
     kb_EXT=#0;
     kb_ESC=#27;
     kb_UP=#72;
     kb_DOWN=#80;
     kb_LEFT=#75;
     kb_RIGHT=#77;
     kb_ENTER=#13;
     kb_SPACE=#32;
     kb_TAB=#9;
     kb_BS=#8;
     kb_HOME=#71;
     kb_END=#79;
     kb_DEL=#83;
     kb_INS=#82;
     kb_PgDn=#81;
     kb_PgUp=#73;
     kb_F1=#59;
     kb_F2=#60;
     kb_F3=#61;
     kb_F4=#62;
     kb_F5=#63;
     kb_F6=#64;
     kb_F7=#65;
     kb_F8=#66;
     kb_F9=#67;
     kb_AltF1=#104;
     kb_AltF2=#105;
     kb_AltF3=#106;
     kb_AltF4=#107;
     kb_AltF5=#108;
     kb_AltF6=#109;
     kb_AltF7=#110;
     kb_AltF8=#111;
     kb_CtrlF1=#94;
     kb_CtrlF2=#95;
     kb_CtrlF3=#96;
     kb_CtrlF4=#97;
     kb_CtrlF5=#98;
     kb_CtrlF6=#99;
     kb_CtrlF9=#102;
     kb_AltX=#45;
     kb_AltC=#46;
     kb_AltD=#32;
     kb_AltE=#18;
     kb_AltF=#33;
     kb_AltG=#34;
     kb_AltH=#35;
     kb_AltI=#23;
     kb_AltJ=#36;
     kb_AltK=#37;
     kb_AltL=#38;
     kb_AltM=#50;
     kb_AltN=#49;
     kb_AltO=#24;
     kb_AltS=#31;
     kb_AltF9=#112;
     kb_AltF10=#113;
     kb_C=#99;
     kb_CtrlC=#3;
     kb_CtrlB=#2;
     kb_CtrlR=#18;
     kb_CtrlO=#15;
     kb_CtrlL=#12;
     kb_CtrlUp=#160;
     kb_CtrlDown=#164;
     kb_CtrlLeft=#115;
     kb_CtrlRight=#116;
     kb_CtrlPgUp=#132;
     kb_CtrlPgDn=#118;
     kb_CtrlENTER=#10;
     kb_CtrlEND=#117;
     kb_INVERSE=#42;
     kb_PLUS=#43;
     kb_MINUS=#45;

Const

(* Function keys *)
   _F1 :word= $3B00;      _ShF1 :word= $5400;     _CtrlF1 :word= $5E00;     _AltF1 :word= $6800;
   _F2 :word= $3C00;      _ShF2 :word= $5500;     _CtrlF2 :word= $5F00;     _AltF2 :word= $6900;
   _F3 :word= $3D00;      _ShF3 :word= $5600;     _CtrlF3 :word= $6000;     _AltF3 :word= $6A00;
   _F4 :word= $3E00;      _ShF4 :word= $5700;     _CtrlF4 :word= $6100;     _AltF4 :word= $6B00;
   _F5 :word= $3F00;      _ShF5 :word= $5800;     _CtrlF5 :word= $6200;     _AltF5 :word= $6C00;
   _F6 :word= $4000;      _ShF6 :word= $5900;     _CtrlF6 :word= $6300;     _AltF6 :word= $6D00;
   _F7 :word= $4100;      _ShF7 :word= $5A00;     _CtrlF7 :word= $6400;     _AltF7 :word= $6E00;
   _F8 :word= $4200;      _ShF8 :word= $5B00;     _CtrlF8 :word= $6500;     _AltF8 :word= $6F00;
   _F9 :word= $4300;      _ShF9 :word= $5C00;     _CtrlF9 :word= $6600;     _AltF9 :word= $7000;
  _F10 :word= $4400;     _ShF10 :word= $5D00;    _CtrlF10 :word= $6700;    _AltF10 :word= $7100;
  _F11 :word= $8500;     _ShF11 :word= $8700;    _CtrlF11 :word= $8900;    _AltF11 :word= $8B00;
  _F12 :word= $8600;     _ShF12 :word= $8800;    _CtrlF12 :word= $8A00;    _AltF12 :word= $8C00;

(* Numeric keypad *)
  Pad8 :word= $4800;     ShPad8 :word= $4838;    CtrlPad8 :word= $8D00;
  Pad2 :word= $5000;     ShPad2 :word= $5032;    CtrlPad2 :word= $9100;
  Pad4 :word= $4B00;     ShPad4 :word= $4B34;    CtrlPad4 :word= $7300;
  Pad6 :word= $4D00;     ShPad6 :word= $4D36;    CtrlPad6 :word= $7400;
  Pad5 :word= $4C00;     ShPad5 :word= $4C35;    CtrlPad5 :word= $8F00;
  Pad0 :word= $5200;     ShPad0 :word= $5230;    CtrlPad0 :word= $9200;
PadDel :word= $5300;   ShPadDel :word= $522E;  CtrlPadDel :word= $9300;
PadMinus:word=$4A2D;                    CtrlPadMinus :word= $8E00; AltPadMinus:word= $4A00;
PadPlus :word=$4E2B;                     CtrlPadPlus :word= $9000; AltPadPlus :word= $4E00;
PadStar :word=$372A;                     CtrlPadStar :word= $9600; AltPadStar :word= $3700;
PadEnter:word=$E00D;                    CtrlPadEnter :word= $E00A; AltPadEnter:word= $A600;
PadSlash:word=$E02F;                    CtrlPadSlash :word= $9500; AltPadSlash:word= $A400;


(* Cursor keys *)
   _Up :word= $48E0;                         _CtrlUp :word= $8DE0;     _AltUp :word= $9800;
  _Down:word= $50E0;                       _CtrlDown :word= $91E0;   _AltDown :word= $A000;
  _Left:word= $4BE0;                       _CtrlLeft :word= $73E0;   _AltLeft :word= $9B00;
 _Right:word= $4DE0;                      _CtrlRight :word= $74E0;  _AltRight :word= $9D00;

 _Home :word= $47E0;    _ShHome :word= $4737;   _CtrlHome :word= $77E0;   _AltHome :word= $9700;
  _End :word= $4FE0;     _Shend :word= $4F31;    _Ctrlend :word= $75E0;    _Altend :word= $9F00;
 _PgUp :word= $49E0;    _ShPgUp :word= $4939;   _CtrlPgUp :word= $84E0;   _AltPgUp :word= $9900;
 _PgDn :word= $51E0;    _ShPgDn :word= $5133;   _CtrlPgDn :word= $76E0;   _AltPgDn :word= $A100;
  _Ins :word= $52E0;     _ShIns :word= $5230;    _CtrlIns :word= $92E0;    _AltIns :word= $A200;
  _Del :word= $53E0;     _ShDel :word= $532E;    _CtrlDel :word= $93E0;    _AltDel :word= $A300;


(* Alphabetic keys *)
 _LowA :word= $1E61;       _UpA :word= $1E41;      _CtrlA :word= $1E01;      _AltA :word= $1E00;
 _LowB :word= $3062;       _UpB :word= $3042;      _CtrlB :word= $3002;      _AltB :word= $3000;
 _LowC :word= $2E63;       _UpC :word= $2E43;      _CtrlC :word= $2E03;      _AltC :word= $2E00;
 _LowD :word= $2064;       _UpD :word= $2044;      _CtrlD :word= $2004;      _AltD :word= $2000;
 _LowE :word= $1265;       _UpE :word= $1245;      _CtrlE :word= $1205;      _AltE :word= $1200;
 _LowF :word= $2166;       _UpF :word= $2146;      _CtrlF :word= $2106;      _AltF :word= $2100;
 _LowG :word= $2267;       _UpG :word= $2247;      _CtrlG :word= $2207;      _AltG :word= $2200;
 _LowH :word= $2368;       _UpH :word= $2348;      _CtrlH :word= $2308;      _AltH :word= $2300;
 _LowI :word= $1769;       _UpI :word= $1749;      _CtrlI :word= $1709;      _AltI :word= $1700;
 _LowJ :word= $246A;       _UpJ :word= $244A;      _CtrlJ :word= $240A;      _AltJ :word= $2400;
 _LowK :word= $256B;       _UpK :word= $254B;      _CtrlK :word= $250B;      _AltK :word= $2500;
 _LowL :word= $266C;       _UpL :word= $264C;      _CtrlL :word= $260C;      _AltL :word= $2600;
 _LowM :word= $326D;       _UpM :word= $324D;      _CtrlM :word= $320D;      _AltM :word= $3200;
 _LowN :word= $316E;       _UpN :word= $314E;      _CtrlN :word= $310E;      _AltN :word= $3100;
 _LowO :word= $186F;       _UpO :word= $184F;      _CtrlO :word= $180F;      _AltO :word= $1800;
 _LowP :word= $1970;       _UpP :word= $1950;      _CtrlP :word= $1910;      _AltP :word= $1900;
 _LowQ :word= $1071;       _UpQ :word= $1051;      _CtrlQ :word= $1011;      _AltQ :word= $1000;
 _LowR :word= $1372;       _UpR :word= $1352;      _CtrlR :word= $1312;      _AltR :word= $1300;
 _LowS :word= $1F73;       _UpS :word= $1F53;      _CtrlS :word= $1F13;      _AltS :word= $1F00;
 _LowT :word= $1474;       _UpT :word= $1454;      _CtrlT :word= $1414;      _AltT :word= $1400;
 _LowU :word= $1675;       _UpU :word= $1655;      _CtrlU :word= $1615;      _AltU :word= $1600;
 _LowV :word= $2F76;       _UpV :word= $2F56;      _CtrlV :word= $2F16;      _AltV :word= $2F00;
 _LowW :word= $1177;       _UpW :word= $1157;      _CtrlW :word= $1117;      _AltW :word= $1100;
 _LowX :word= $2D78;       _UpX :word= $2D58;      _CtrlX :word= $2D18;      _AltX :word= $2D00;
 _LowY :word= $1579;       _UpY :word= $1559;      _CtrlY :word= $1519;      _AltY :word= $1500;
 _LowZ :word= $2C7A;       _UpZ :word= $2C5A;      _CtrlZ :word= $2C1A;      _AltZ :word= $2C00;

_LowrA :word= $1EE4;      _UprA :word= $1E94;
_LowrB :word= $30A8;      _UprB :word= $3088;
_LowrC :word= $2EE1;      _UprC :word= $2E91;
_LowrD :word= $20A2;      _UprD :word= $2082;
_LowrE :word= $12E3;      _UprE :word= $1293;
_LowrF :word= $21A0;      _UprF :word= $2180;
_LowrG :word= $22AF;      _UprG :word= $228F;
_LowrH :word= $23E0;      _UprH :word= $2390;
_LowrI :word= $17E8;      _UprI :word= $1798;
_LowrJ :word= $24AE;      _UprJ :word= $248E;
_LowrK :word= $25AB;      _UprK :word= $258B;
_LowrL :word= $26A4;      _UprL :word= $2684;
_LowrM :word= $32EC;      _UprM :word= $329C;
_LowrN :word= $31E2;      _UprN :word= $3192;
_LowrO :word= $18E9;      _UprO :word= $1899;
_LowrP :word= $19A7;      _UprP :word= $1987;
_LowrQ :word= $10A9;      _UprQ :word= $1089;
_LowrR :word= $13AA;      _UprR :word= $138A;
_LowrS :word= $1FEB;      _UprS :word= $1F9B;
_LowrT :word= $14A5;      _UprT :word= $1485;
_LowrU :word= $16A3;      _UprU :word= $1683;
_LowrV :word= $2FAC;      _UprV :word= $2F8C;
_LowrW :word= $11E6;      _UprW :word= $1196;
_LowrX :word= $2DE7;      _UprX :word= $2D97;
_LowrY :word= $15AD;      _UprY :word= $158D;
_LowrZ :word= $2CEF;      _UprZ :word= $2C9F;

(* Number keys, on top row of keyboard *)
 _Num1 :word= $0231;    _ShNum1 :word= $0221;                           _Alt1 :word= $7800;
 _Num2 :word= $0332;    _ShNum2 :word= $0340;      _Ctrl2 :word= $0300;      _Alt2 :word= $7900;
 _Num3 :word= $0433;    _ShNum3 :word= $0423;                           _Alt3 :word= $7A00;
 _Num4 :word= $0534;    _ShNum4 :word= $0424;                           _Alt4 :word= $7B00;
 _Num5 :word= $0635;    _ShNum5 :word= $0424;                           _Alt5 :word= $7C00;
 _Num6 :word= $0736;    _ShNum6 :word= $075E;      _Ctrl6 :word= $071E;      _Alt6 :word= $7D00;
 _Num7 :word= $0837;    _ShNum7 :word= $0826;                           _Alt7 :word= $7E00;
 _Num8 :word= $0938;    _ShNum8 :word= $092A;                           _Alt8 :word= $7F00;
 _Num9 :word= $0A39;    _ShNum9 :word= $0A28;                           _Alt9 :word= $8000;
 _Num0 :word= $0B30;    _ShNum0 :word= $0B29;                           _Alt0 :word= $8100;

                  _ShNumR2 :word= $0322;
                  _ShNumR3 :word= $04FC;
                  _ShNumR4 :word= $053B;
                  _ShNumR5 :word= $0625;
                  _ShNumR6 :word= $073A;
                  _ShNumR7 :word= $083F;
                  _ShNumR8 :word= $092A;
                  _ShNumR9 :word= $0A28;
                  _ShNumR0 :word= $0B29;


(* Miscellaneous *)
  _Space :word= $3920;
   _BkSp :word= $0E08;                     _CtrlBkSp :word= $0E7F;   _AltBkSp :word= $0E00;
    _Tab :word= $0F09;   _ShTab :word= $0F00;   _CtrlTab  :word= $9400;    _AltTab :word= $A500;
  _Enter :word= $1C0D;                     _CtrlEnter:word= $1C0A;  _AltEnter :word= $1C00;
    _Esc :word= $011B;                                           _AltEsc :word= $0100;


  _Tilda :word= $2960; _ShTilda :word= $297E;                       _AltTilda :word= $2900;
 _TildaR :word= $29F1;_ShTildaR :word= $00F0;
 _OpScob :word= $1A5B;_ShOpScob :word= $1A7B; _CtrlOpScob :word= $1A1B; _AltOpScob :word= $1A00;
 _ClScob :word= $1B5D;_ShClScob :word= $1B7D; _CtrlClScob :word= $1B1D; _AltClScob :word= $1B00;
_OpScobR :word= $1AE5;_ShOpScobR:word= $1A95;_CtrlOpScobR :word= $1A1B;_AltOpScobR :word= $1A00;
_ClScobR :word= $1BEA;_ShClScobR:word= $1B9A;_CtrlClScobR :word= $1B1D;_AltClScobR :word= $1B00;
_BkSlash :word= $2B5C;_ShBkSlash:word= $2B7C;_CtrlBkSlash :word= $2B1C;_AltBkSlash :word= $2B00;
                 _ShBkSlashR:word=$2B2F;

 _Slash  :word= $352F; _ShSlash :word= $353F;                      _AltSlash  :word= $3500;
 _SlashR :word= $352E; _ShSlashR:word= $352C;

  _Minus :word= $0C2D;                    _CtrlMinus :word= $0C1F;  _AltMinus :word= $8200;
   _Plus :word= $0D2B;                                          _AltPlus :word= $8300;
   _Star :word= $092A;



function KeyCode:word;
function KeyCodePressed(var kc:word):boolean;
function Ctrl:boolean;
function Alt:boolean;
function LShift:boolean;
function RShift:boolean;


{===== WINDOWS SECTION =====}
function WinX   :boolean;
function WinVer :word;
function Is95   :boolean;




{===== MOUSE SECTION =====}

var
   Moused: boolean;
{
procedure rMouseOn;
procedure rMouseOff;

function InitMouseOk : boolean;
function GetButton : byte;
function GetX : byte;
function GetY : byte;
procedure GetMousePos(var x,y : integer);
procedure MouseShow;
procedure MouseHide;
{}





{===== MOUSE SECTION =====}




{===== CONVERT SECTION =====}
function dec2hex(decn:string):string;
function hex2dec(hex:string):string;
function hex2bin(hex:string):string;
function bin2hex(bin:string):string;
FUNCTION Hexlong(argument:longint):string;
{===== CONVERT SECTION =====}


Implementation
{$I rvCRT.pas}
{$I rvDOS.pas}
{$I rvSTR.pas}
{$I rvPUTS.pas}
{$I rvWIN.pas}
{$I rvDOS95.pas}
{$I rvKEYB.pas}
{$I rvCONV.pas}


Begin
gmaxx:=maxx;
gmaxy:=maxy;
halfmaxx:=gmaxx div 2;
halfmaxy:=gmaxy div 2;
{
menu_visible:=255;
menu_mayins:=false;
menu_posx:=255; menu_posy:=255;
{}
rvPutsInit;

WinNum:=1;
w_animation:=false;
w_twosided:=true;
w_rama:=true;
w_shadow:=true;
moused:=false;
End.